'From Squeak2.8alpha of 9 March 2000 [latest update: #2098] on 16 May 2000 at 8:27:04 pm'!
RectangleMorph subclass: #ConfirmationMorph
	instanceVariableNames: 'string confirmType answer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Dialogs'!

!Morph methodsFor: 'dialogs' stamp: 'rca 5/16/2000 18:26'!
confirm: string
	| a b |
	"Be modal-ish at window level if possible"
	a _ self outermostMorphThat: [:each | each isKindOf: SystemWindow].
	a ifNil: [self isHandMorph 
			ifTrue:  [a _ self world]
			ifFalse: [a _ self]].
	a addMorphFront: (b _ ConfirmationMorph new).
	^ b confirm: string.
! !

!Morph methodsFor: 'dialogs' stamp: 'rca 5/16/2000 19:19'!
confirm: aString orCancel: cancelBlock
	"Put up a yes/no/cancel menu with caption aString.
	Answer true if the response is yes, false if no.
	If cancel is chosen, evaluate cancelBlock."
	| a b |
	"Be modal-ish at window level if possible"
	a _ self outermostMorphThat: [:each | each isKindOf: SystemWindow].
	a ifNil: [self isHandMorph 
			ifTrue:  [a _ self world]
			ifFalse: [a _ self]].
	a addMorphFront: (b _ ConfirmationMorph new).
	^ b confirm: aString orCancel: cancelBlock.
! !

!Morph methodsFor: 'dialogs' stamp: 'rca 5/16/2000 19:47'!
inform: string
	| a b |
	"Be modal-ish at window level if possible"
	a _ self outermostMorphThat: [:each | each isKindOf: SystemWindow].
	a ifNil: [self isHandMorph 
			ifTrue:  [a _ self world]
			ifFalse: [a _ self]].
	a addMorphFront: (b _ ConfirmationMorph new).
	^ b inform: string.
! !


!ConfirmationMorph methodsFor: 'initialization' stamp: 'rca 5/16/2000 20:07'!
confirm: aString 
	| a b c w |
	string _ aString.
	confirmType _ #confirm.

	self color: self defaultColor.

	self addMorph: (a _ TextMorph new).
	a contents: aString;
	 centered;
	name: #query.

	self addMorph: (b _ SimpleButtonMorph new).
	b target: self;
	 label: 'Yes';
	 actionSelector: #confirmYes;
	name: #confirmYes.

	self addMorph: (c _ SimpleButtonMorph new).
	c target: self;
	 label: 'No';
	 actionSelector: #confirmNo;
	name: #confirmNo.

	self addMorph: (c _ ImageMorph new image: (ImageImports at: 'confirm')).
	c name: #icon.
	self layoutChanged.

	w _ self world.
	[answer isNil]
		whileTrue: [w doOneCycle].
	self delete.
	^ answer! !

!ConfirmationMorph methodsFor: 'initialization' stamp: 'rca 5/16/2000 20:11'!
confirm: aString orCancel: aBlock
	| a b c w d e |
	string _ aString.
	confirmType _ #confirmCancel.

	self color: self defaultColor.

	self addMorph: (a _ TextMorph new).
	a contents: aString;
	 centered;
	name: #query.

	self addMorph: (b _ SimpleButtonMorph new).
	b target: self;
	 label: 'Yes';
	 actionSelector: #confirmYes;
	name: #confirmYes.

	self addMorph: (c _ SimpleButtonMorph new).
	c target: self;
	 label: 'No';
	 actionSelector: #confirmNo;
	name: #confirmNo.

	self addMorph: (d _ SimpleButtonMorph new).
	d target: self;
	 label: 'Cancel';
	 actionSelector: #confirmCancel;
	name: #confirmCancel.

	self addMorph: (e _ ImageMorph new image: (ImageImports at: 'confirmcancel')).
	e name: #icon.
	self layoutChanged.

	w _ self world.
	[answer isNil]
		whileTrue: [w doOneCycle].
	self delete.
	answer == #cancel ifTrue: [^aBlock value].
	^answer! !

!ConfirmationMorph methodsFor: 'initialization' stamp: 'rca 5/16/2000 20:11'!
inform: aString 
	| a b w c |
	string _ aString.
	confirmType _ #inform.

	self color: self defaultColor.

	self addMorph: (a _ TextMorph new).
	a contents: aString;
	 centered;
	name: #query.

	self addMorph: (b _ SimpleButtonMorph new).
	b target: self;
	 label: 'OK';
	 actionSelector: #confirmYes;
	name: #confirmYes.

	self addMorph: (c _ ImageMorph new image: (ImageImports at: 'inform')).
	c name: #icon.
	self layoutChanged.

	w _ self world.
	[answer isNil]
		whileTrue: [w doOneCycle].
	self delete.
	^ answer! !

!ConfirmationMorph methodsFor: 'initialization' stamp: 'rca 5/16/2000 19:35'!
initialize

	super initialize.
	bounds _ World bounds.
! !

!ConfirmationMorph methodsFor: 'preferences' stamp: 'rca 5/16/2000 17:57'!
defaultColor
	^(Color
		r: 1
		g: 1
		b: 1
		alpha: 0.6).! !

!ConfirmationMorph methodsFor: 'change reporting' stamp: 'rca 5/16/2000 20:09'!
changedConfirm
	| a b c|
	(a _ self submorphNamed: #query ifNone: [^self])
		 position: (self right + self left) // 2 - (a width // 2) @ (self top + self bottom // 2 - (a height // 2)).

	(b _ self submorphNamed: #confirmYes  ifNone: [^self])
		 position: (self right + self left) // 2 - (b width //2) - 40 @ (self top + self bottom // 2 + (a height // 2) + 10).

	(self submorphNamed: #confirmNo  ifNone: [^self])
		 position: (self right + self left) // 2  - (b width //2) + 40 @ (self top + self bottom // 2 + (a height // 2) + 10).

	(c _ self submorphNamed: #icon  ifNone: [^self])
		 position: (self right + self left) // 2  - (c width //2)  @ (self top + self bottom // 2 - (a height) - (c height)).
	

! !

!ConfirmationMorph methodsFor: 'change reporting' stamp: 'rca 5/16/2000 20:10'!
changedConfirmCancel
	| a b c d|
	(a _ self submorphNamed: #query ifNone: [^self])
		 position: (self right + self left) // 2 - (a width // 2) @ (self top + self bottom // 2 - (a height // 2)).

	(c _ self submorphNamed: #confirmNo  ifNone: [^self])
		 position: (self right + self left) // 2 - (c width //2) @ (self top + self bottom // 2 + (a height // 2) + 10).

	(b _ self submorphNamed: #confirmYes  ifNone: [^self])
		 position: (self right + self left) // 2 - (c width //2) - (b width) -  20 @ (self top + self bottom // 2 + (a height // 2) + 10).
	
	(self submorphNamed: #confirmCancel  ifNone: [^self])
		 position: (self right + self left) // 2   +  (c width //2) + 20 @ (self top + self bottom // 2 + (a height // 2) + 10).

	(d _ self submorphNamed: #icon  ifNone: [^self])
		 position: (self right + self left) // 2  - (d width //2)  @ (self top + self bottom // 2 - (a height) - (d height)).
! !

!ConfirmationMorph methodsFor: 'change reporting' stamp: 'rca 5/16/2000 20:10'!
changedInform
	| a b c |
	(a _ self submorphNamed: #query ifNone: [^self])
		 position: (self right + self left) // 2 - (a width // 2) @ (self top + self bottom // 2 - (a height // 2)).

	(b _ self submorphNamed: #confirmYes  ifNone: [^self])
		 position: ((self right + self left) // 2 - (b width //2)) @ (self top + self bottom // 2 + (a height // 2) + 30).

	(c _ self submorphNamed: #icon  ifNone: [^self])
		 position: (self right + self left) // 2  - (c width //2)  @ (self top + self bottom // 2 - (a height) - (c height)).

! !

!ConfirmationMorph methodsFor: 'change reporting' stamp: 'rca 5/16/2000 19:35'!
layoutChanged
	owner ifNil: [^self].
	self height: owner height.
	self width: owner width.
	self position: owner position.

	confirmType caseOf: {
		[#confirm] -> [self changedConfirm].
		[#confirmCancel] -> [self changedConfirmCancel].
		[#inform] -> [self changedInform]}
		otherwise: [].

! !

!ConfirmationMorph methodsFor: 'change reporting' stamp: 'rca 5/16/2000 17:26'!
ownerChanged
	^ self layoutChanged
	
! !

!ConfirmationMorph methodsFor: 'event handling' stamp: 'rca 5/16/2000 17:20'!
handlesMouseDown: evt
	"freezes underlying morph"
	^ true! !

!ConfirmationMorph methodsFor: 'event handling' stamp: 'rca 5/16/2000 19:14'!
mouseDown: evt

	owner isWorldMorph ifFalse: [evt hand grabMorph: owner].! !

!ConfirmationMorph methodsFor: 'button interface' stamp: 'rca 5/16/2000 17:38'!
confirmCancel
	answer _ #cancel.! !

!ConfirmationMorph methodsFor: 'button interface' stamp: 'rca 5/16/2000 17:37'!
confirmNo
	answer _ false.! !

!ConfirmationMorph methodsFor: 'button interface' stamp: 'rca 5/16/2000 17:37'!
confirmYes
	answer _ true.! !


!ConfirmationMorph class methodsFor: 'as yet unclassified' stamp: 'rca 5/16/2000 20:26'!
initialize

	Smalltalk imageImports
		 at: 'inform' put: (Form fromFileNamed: 'inform.gif');
		 at: 'confirm' put: (Form fromFileNamed: 'confirm.gif');
		 at: 'confirmcancel' put: (Form fromFileNamed: 'confirmcancel.gif').
! !

ConfirmationMorph initialize!

!ConfirmationMorph reorganize!
('initialization' confirm: confirm:orCancel: inform: initialize)
('preferences' defaultColor)
('change reporting' changedConfirm changedConfirmCancel changedInform layoutChanged ownerChanged)
('event handling' handlesMouseDown: mouseDown:)
('button interface' confirmCancel confirmNo confirmYes)
!

